/**
  ******************************************************************************
  * @file    vkl144.h 
  * @author  kevin_guo
  * @version V1.2
  * @date    05-17-2020
  * @brief   Header files for Vkl144
  ******************************************************************************
  * @attention
  ******************************************************************************
  */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __VKl144_H
#define __VKl144_H

/* Includes ------------------------------------------------------------------*/
//˰ļݿͻƬӦ޸
#include "M451Series.h"
/* Exported types ------------------------------------------------------------*/
/* Exported constants --------------------------------------------------------*/
/* Exported macro ------------------------------------------------------------*/
/* Exported define -----------------------------------------------------------*/
//
#define Vkl144_ADDR   					0x7c    // IICַ
//#define Vkl144_ICSET       			0xe8    // IC  bit0ʱԴ  bit1λ      bit2ӳַbit5
//																				// ĬΪ0 ڲRC  ִλ  
#define Vkl144_SOFTRST       		0xea    //ִλ   
#define Vkl144_ADDR5_0       		0xe8    //ӳַbit5 
#define Vkl144_ADDR5_1       		0xec    //ӳַbit5 
#define Vkl144_ADSET       			0x00    //ӳַbit4-0 
#define Vkl144_MODESET_1_3_ON  	0xc8    // ʾ 1/3bias
#define Vkl144_MODESET_1_3_OFF 	0xc0    // رʾ 1/3bias
#define Vkl144_MODESET_1_2_ON  	0xcc    // ʾ 1/2bias
#define Vkl144_MODESET_1_2_OFF 	0xc4    // رʾ 1/2bias
//ʾ
#define Vkl144_DISCTL			      0xA0  	//bit7~bit5=101 
//bit4-bit3ʡģʽFR bit2LINE,FRAME bit1-bit0ʡģʽSR
//Inor=1  Im1=0.5Inor  Im2=0.67Inor  Ihp=1.8Inor
//ʡģʽFR
#define Vkl144_FRNOR       0x00  //bit4-bit3=00   FR NORMAL 					ϵĬ 
#define Vkl144_FRPM1       0x08  //bit4-bit3=01   FR POWER SAVE MODE1
#define Vkl144_FRPM2       0x10  //bit4-bit3=10   FR POWER SAVE MODE2
#define Vkl144_FRPM3       0x18  //bit4-bit3=11   FR POWER SAVE MODE3 ʡ
//ʡģʽSR
#define Vkl144_SRHP        0x03  //bit1-bit0=11   SR NORMAL 
#define Vkl144_SRNOR       0x02  //bit1-bit0=10   SR POWER SAVE MODE1 ϵĬ 
#define Vkl144_SRPM2       0x01  //bit1-bit0=01   SR POWER SAVE MODE2
#define Vkl144_SRPM1       0x00  //bit1-bit0=00   SR POWER SAVE MODE1 ʡ
//LINE FRAME
#define Vkl144_LINER       0x00  //bit2=0   LINEת	ϵĬ
#define Vkl144_FRAMER      0x04  //bit2=1   FRAMEת ʡ
//ʾ
//Vkl144_FRPM1|Vkl144_SRPM1|Vkl144_FRAMER    //
//Vkl144_FRPM2|Vkl144_SRPM1|Vkl144_FRAMER    //
//Vkl144_FRPM3|Vkl144_SRPM1|Vkl144_FRAMER    //ʡ
//Vkl144_FRNOR|Vkl144_SRHP|Vkl144_LINER      //
//˸
#define Vkl144_BLKCTL_OFF      0xF0  // ر˸
#define Vkl144_BLKCTL_05HZ     0xF1  // ˸ƵΪ0.5HZ
#define Vkl144_BLKCTL_1HZ      0xF2  // ˸ƵΪ1HZ
#define Vkl144_BLKCTL_2HZ      0xF3  // ˸ƵΪ2HZ
//ȫǿп,ʾڴ޹,ȫΪִ
#define Vkl144_APCTL_APON_ON   0xFE // ȫǿȫʾ_
#define Vkl144_APCTL_APON_OFF  0xFC // ȫǿȫʾ_
#define Vkl144_APCTL_APOFF_ON  0xFD // ȫǿйʾ_
#define Vkl144_APCTL_APOFF_OFF 0xFC // ȫǿйʾ_

//seg
#define 	Vkl144_SEGNUM				36

//¹ܽøݿͻƬӦ޸ 
#define Vkl144_SCL_PIN    BIT13
#define Vkl144_SCL_PORT   PA
#define Vkl144_SCL_IO     PA13

#define Vkl144_SDA_PIN    BIT15
#define Vkl144_SDA_PORT   PA
#define Vkl144_SDA_IO     PA15

//¹ܽݿͻƬӦ޸
#define Vkl144_SCL_H() 				Vkl144_SCL_IO = 1 
#define Vkl144_SCL_L() 				Vkl144_SCL_IO = 0 

#define Vkl144_SDA_H() 				Vkl144_SDA_IO = 1 
#define Vkl144_SDA_L() 				Vkl144_SDA_IO = 0 

#define Vkl144_GET_SDA() 			Vkl144_SDA_IO
//ƬSDAΪIOҪΪ
//ݿͻƬ޸
#define Vkl144_DIRDAT_PIN   	BIT0
#define Vkl144_DIRDAT_PORT  	PB
#define Vkl144_DIRDAT_IO    	PB0
#define Vkl144_DIRDAT1_PIN   	BIT12
#define Vkl144_DIRDAT1_PORT  	PA
#define Vkl144_DIRDAT1_IO    	PA12
#define Vkl144_SET_SDA_DIR() 	{\
	GPIO_SetMode(Vkl144_DIRDAT_PORT, Vkl144_DIRDAT_PIN, GPIO_MODE_OUTPUT);\
	GPIO_SetMode(Vkl144_DIRDAT1_PORT, Vkl144_DIRDAT1_PIN, GPIO_MODE_OUTPUT);\
}
#define Vkl144_SET_SDA_IN() 	{\
  Vkl144_DIRDAT_IO = 0;\
  Vkl144_DIRDAT1_IO = 0;\
}
#define Vkl144_SET_SDA_OUT() 	{\
 	Vkl144_DIRDAT_IO = 1;\
  Vkl144_DIRDAT1_IO = 1;\
}
/* Exported functions ------------------------------------------------------- */
void Vkl144_Init(void);
void Vkl144_DisAll(unsigned char dat);
void Vkl144_DisSegComOn(unsigned char seg,unsigned char com);
void Vkl144_DisSegComOff(unsigned char seg,unsigned char com);

void Vkl144_Main(void);
#endif  /*__VKl144_H*/

/************************END OF FILE****/
